/*
 * このソースコードは blanco Frameworkによって自動生成されています。
 * Apache Antタスク [BlancoNLpackGeneratorDiffXliffPleiadesToTranslationFragment]のクラス
 */
package blanco.nlpack.generator.task;

import org.apache.tools.ant.BuildException;
import org.apache.tools.ant.Task;

import blanco.nlpack.generator.task.valueobject.BlancoNLpackGeneratorDiffXliffPleiadesToTranslationFragmentProcessInput;

/**
 * Apache Antタスク [BlancoNLpackGeneratorDiffXliffPleiadesToTranslationFragment]のクラス。
 *
 * [XLIFF対応ツール] XLIFFとPleiadesの差分を抽出し、翻訳フラグメントに出力します。<br>
 * このクラスでは、Apache Antタスクで一般的に必要なチェックなどのコーディングを肩代わりします。
 * 実際の処理は パッケージ[blanco.nlpack.generator.task]にBlancoNLpackGeneratorDiffXliffPleiadesToTranslationFragmentBatchProcessクラスを作成して記述してください。<br>
 * <br>
 * Antタスクへの組み込み例<br>
 * <pre>
 * &lt;taskdef name=&quot;blanconlpackgeneratordiffxliffpleiadestotranslationfragment&quot; classname=&quot;blanco.nlpack.generator.task.BlancoNLpackGeneratorDiffXliffPleiadesToTranslationFragmentTask">
 *     &lt;classpath&gt;
 *         &lt;fileset dir=&quot;lib&quot; includes=&quot;*.jar&quot; /&gt;
 *         &lt;fileset dir=&quot;lib.ant&quot; includes=&quot;*.jar&quot; /&gt;
 *     &lt;/classpath&gt;
 * &lt;/taskdef&gt;
 * </pre>
 */
public class BlancoNLpackGeneratorDiffXliffPleiadesToTranslationFragmentTask extends Task {
    /**
     * [XLIFF対応ツール] XLIFFとPleiadesの差分を抽出し、翻訳フラグメントに出力します。
     */
    protected BlancoNLpackGeneratorDiffXliffPleiadesToTranslationFragmentProcessInput fInput = new BlancoNLpackGeneratorDiffXliffPleiadesToTranslationFragmentProcessInput();

    /**
     * [XLIFF対応ツール] XLIFFとPleiadesの差分を抽出し、翻訳フラグメントに出力します。
     */
    protected boolean fIsFieldXliffdirProcessed = false;

    /**
     * [XLIFF対応ツール] XLIFFとPleiadesの差分を抽出し、翻訳フラグメントに出力します。
     */
    protected boolean fIsFieldTargetfileProcessed = false;

    /**
     * [XLIFF対応ツール] XLIFFとPleiadesの差分を抽出し、翻訳フラグメントに出力します。
     */
    protected boolean fIsFieldIsoutputaddProcessed = false;

    /**
     * [XLIFF対応ツール] XLIFFとPleiadesの差分を抽出し、翻訳フラグメントに出力します。
     */
    protected boolean fIsFieldIsoutputchangeProcessed = false;

    /**
     * verboseモードで動作させるかどうか。
     *
     * @param arg verboseモードで動作させるかどうか。
     */
    public void setVerbose(final boolean arg) {
        fInput.setVerbose(arg);
    }

    /**
     * verboseモードで動作させるかどうか。
     *
     * @return verboseモードで動作させるかどうか。
     */
    public boolean getVerbose() {
        return fInput.getVerbose();
    }

    /**
     * Antタスクの[xliffdir]アトリビュートのセッターメソッド。
     *
     * 項目番号: 1<br>
     * XLIFFファイルが格納されている入力先ルート・フォルダを指定します。<br>
     *
     * @param arg セットしたい値
     */
    public void setXliffdir(final String arg) {
        fInput.setXliffdir(arg);
        fIsFieldXliffdirProcessed = true;
    }

    /**
     * Antタスクの[xliffdir]アトリビュートのゲッターメソッド。
     *
     * 項目番号: 1<br>
     * XLIFFファイルが格納されている入力先ルート・フォルダを指定します。<br>
     * 必須アトリビュートです。Apache Antタスク上で必ず値が指定されます。<br>
     *
     * @return このフィールドの値
     */
    public String getXliffdir() {
        return fInput.getXliffdir();
    }

    /**
     * Antタスクの[targetfile]アトリビュートのセッターメソッド。
     *
     * 項目番号: 2<br>
     * 出力先となる翻訳フラグメントファイル。<br>
     *
     * @param arg セットしたい値
     */
    public void setTargetfile(final String arg) {
        fInput.setTargetfile(arg);
        fIsFieldTargetfileProcessed = true;
    }

    /**
     * Antタスクの[targetfile]アトリビュートのゲッターメソッド。
     *
     * 項目番号: 2<br>
     * 出力先となる翻訳フラグメントファイル。<br>
     * 必須アトリビュートです。Apache Antタスク上で必ず値が指定されます。<br>
     *
     * @return このフィールドの値
     */
    public String getTargetfile() {
        return fInput.getTargetfile();
    }

    /**
     * Antタスクの[isoutputadd]アトリビュートのセッターメソッド。
     *
     * 項目番号: 3<br>
     * add を出力するかどうか。<br>
     *
     * @param arg セットしたい値
     */
    public void setIsoutputadd(final boolean arg) {
        fInput.setIsoutputadd(arg);
        fIsFieldIsoutputaddProcessed = true;
    }

    /**
     * Antタスクの[isoutputadd]アトリビュートのゲッターメソッド。
     *
     * 項目番号: 3<br>
     * add を出力するかどうか。<br>
     * デフォルト値[true]が設定されています。Apache Antタスク上でアトリビュートの指定が無い場合には、デフォルト値が設定されます。<br>
     *
     * @return このフィールドの値
     */
    public boolean getIsoutputadd() {
        return fInput.getIsoutputadd();
    }

    /**
     * Antタスクの[isoutputchange]アトリビュートのセッターメソッド。
     *
     * 項目番号: 4<br>
     * change を出力するかどうか。<br>
     *
     * @param arg セットしたい値
     */
    public void setIsoutputchange(final boolean arg) {
        fInput.setIsoutputchange(arg);
        fIsFieldIsoutputchangeProcessed = true;
    }

    /**
     * Antタスクの[isoutputchange]アトリビュートのゲッターメソッド。
     *
     * 項目番号: 4<br>
     * change を出力するかどうか。<br>
     * デフォルト値[true]が設定されています。Apache Antタスク上でアトリビュートの指定が無い場合には、デフォルト値が設定されます。<br>
     *
     * @return このフィールドの値
     */
    public boolean getIsoutputchange() {
        return fInput.getIsoutputchange();
    }

    /**
     * Antタスクのメイン処理。Apache Antから このメソッドが呼び出されます。
     *
     * @throws BuildException タスクとしての例外が発生した場合。
     */
    public final void execute() throws BuildException {
        System.out.println("BlancoNLpackGeneratorDiffXliffPleiadesToTranslationFragmentTask begin.");

        // 項目番号[1]、アトリビュート[xliffdir]は必須入力です。入力チェックを行います。
        if (fIsFieldXliffdirProcessed == false) {
            throw new BuildException("必須アトリビュート[xliffdir]が設定されていません。処理を中断します。");
        }
        // 項目番号[2]、アトリビュート[targetfile]は必須入力です。入力チェックを行います。
        if (fIsFieldTargetfileProcessed == false) {
            throw new BuildException("必須アトリビュート[targetfile]が設定されていません。処理を中断します。");
        }

        if (getVerbose()) {
            System.out.println("- verbose:[true]");
            System.out.println("- xliffdir:[" + getXliffdir() + "]");
            System.out.println("- targetfile:[" + getTargetfile() + "]");
            System.out.println("- isoutputadd:[" + getIsoutputadd() + "]");
            System.out.println("- isoutputchange:[" + getIsoutputchange() + "]");
        }

        try {
            // 実際のAntタスクの主処理を実行します。
            // この箇所でコンパイルエラーが発生する場合、BlancoNLpackGeneratorDiffXliffPleiadesToTranslationFragmentProcessインタフェースを実装して blanco.nlpack.generator.taskパッケージに BlancoNLpackGeneratorDiffXliffPleiadesToTranslationFragmentProcessImplクラスを作成することにより解決できる場合があります。
            final BlancoNLpackGeneratorDiffXliffPleiadesToTranslationFragmentProcess proc = new BlancoNLpackGeneratorDiffXliffPleiadesToTranslationFragmentProcessImpl();
            if (proc.execute(fInput) != BlancoNLpackGeneratorDiffXliffPleiadesToTranslationFragmentBatchProcess.END_SUCCESS) {
                throw new BuildException("タスクは異常終了しました。");
            }
        } catch (IllegalArgumentException e) {
            if (getVerbose()) {
                e.printStackTrace();
            }
            throw new BuildException(e.getMessage());
        } catch (Exception e) {
            e.printStackTrace();
            throw new BuildException("タスクを処理中に例外が発生しました。処理を中断します。" + e.toString());
        } catch (Error e) {
            e.printStackTrace();
            throw new BuildException("タスクを処理中にエラーが発生しました。処理を中断します。" + e.toString());
        }
    }
}
